#ifndef Model_c
#define OBC	  0	/* 1=open,0=periodic boundery contition */
#define N0	  4     /* number of spin-1 sites */
#define NN    (2*N0)	/* 8d2 10h7 16q0 20d4 24d6 26h5 32q4 36s0 64o0 */
#define N1        1     /* N1=1 N2=0 -> chain */
#define N2        0
#define Title     "S=1 Heisenberg chain PBC"    /* 123456789=hdtqps..o. */
#define Spin1chain 1    /* used in chk3, expection values, stringorderpara */
#define Sym    (N0)	/* Symmetrien */
#define Sud       1
#define CM(JJ,tJ,tU) JJ	  /* Heisenberg-,  t-J- or  Hubbard-model */

#if N1>1 || N2>0
#define Nw (6*N0*4)                 /* Betts-lattice */
#elif N0>3
#define Nw (2*N0*4)		/* besser noch ein Jf zwischen Spin 1/2 */
#else				/* zur "Staerkung" der Tripletts */
#define Nw (N0*4)		/* und Absenkung der S=1 Energien Jf=-10 */
#endif
#define Ne NN
#define SBase 1		/* SBase/noSBase = with/without symmetry */ 
#endif
int initvars();		/* declaration */
#ifdef Model_c
/* ================== 2D-Gitter nach Betts =========================== */
/* => Betts-Notation example: 14h4 => N=14,N1=1,N2=4 => 1 helix, dy=4 */

  /*  i=site 0..NN, d=direction 0..2, s=steps ..,-1,0,1,.. rc=i+s*vec_d */
  /* besser site(i,dx,dy[,dz])  dy<0 geht nicht !!!!  */
  int site_move(int i,int dx,int dy,...){ int j;
    if(i<0 || i>=NN)return -1;j=i/N0;i=i%N0;
    while(dx<0)dx+=N0/N1;while(dy<0)dy+=N1;
    i=(i+dx)%(N0/N1)+(i/(N0/N1))*(N0/N1);		/* x-direction */
    i=(i+dy+((i/(N0/N1)+dy)/N1)*(N2-N1+NN/N1))%(N0/N1)+
                   ((i/(N0/N1)+dy)%N1)*(N0/N1);		/* y-direction */
    return(i+j*N0);}

  int initvars(){
    int i,j,k; 
    nu=NN/2;nd=NN/2+NN%2;
#define Bd(l,a,b) for(i=0;i<N0;i++){\
    iw[l     ][0]=a;   iw[l     ][1]=b;   printf(" %i-%i",a,b);\
    iw[l+1*N0][0]=a+N0;iw[l+1*N0][1]=b;   \
    iw[l+2*N0][0]=a;   iw[l+2*N0][1]=b+N0;\
    iw[l+3*N0][0]=a+N0;iw[l+3*N0][1]=b+N0;}
#define NL printf("\n")
#if N1>1 || N2>0
    Bd(i      ,i,site_move(i,1, 0));
    Bd(i+ 4*N0,i,site_move(i,0, 1));
    Bd(i+ 8*N0,i,site_move(i,1, 1));
    Bd(i+12*N0,i,site_move(i,-1,1));
#if Nw>16*N0
    printf("2x :");Bd(i+16*N0,i,site_move(i,2,0));NL;
    Bd(i+20*N0,i,site_move(i,0,2));
#endif    
    for(i=0;i< Nw;i++)wj[i]=(i<8*N0)? 1:(i<16*N0)? 2 : 3;
    for(i=0;i< Nw;i++)wt[i]=(i<8*N0)? 4:(i<16*N0)? 5 : 6;
#else	/* Kette */
    Bd(i     ,i,site_move(i,1, 0));
#if Nw>4*N0    
    Bd(i+4*N0,i,site_move(i,2, 0));
#endif
    for(i=0;i< Nw;i++)wj[i]=(i<4*N0)? 1:(i<8*N0)? 2 : 3;
    for(i=0;i< Nw;i++)wt[i]=(i<4*N0)? 4:(i<8*N0)? 5 : 6;
#if OBC
    for(i=0;i<4;i++)wj[N0-1+i*N0]=0;
    for(i=0;i<4;i++)wt[N0-1+i*N0]=0;
#if Nw>4*N0    
    for(i=0;i<4;i++)wj[5*N0-1+i*N0]=0;
    for(i=0;i<4;i++)wt[5*N0-1+i*N0]=0;
#endif
#endif
#endif
    for(i=0;i< NN;i++)we[i]= 7;
    for(i=0;i< NN;i++)wu[i]= 8;
    numpara=CM(4,7,9);
    para[0]= 0.0;	/* immer 0 */
    para[1]= 1.0;	/* J1 */
    para[2]= 0.4;	/* J2 */
    para[3]= 0.0;	/* J3 */
    para[4]=-1.0;	/* t1 */
    para[5]= 0.1;	/* t2 */
    para[6]=-0.2;	/* t3 */
    para[7]= 0.0;	/* e */
    para[8]= 8.0;	/* U */
    return 0;}    
#endif
